"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var react_test_renderer_1 = __importDefault(require("react-test-renderer"));
var withESI_1 = __importDefault(require("./withESI"));
var Dummy = function (props) { return react_1.default.createElement("div", null,
    "Hello ",
    props.name); };
test("client-side", function () {
    var DummyESI = withESI_1.default(Dummy, "id");
    expect(DummyESI.displayName).toBe("WithESI(Dummy)");
    global.process.browser = true;
    var component = react_test_renderer_1.default.create(react_1.default.createElement(DummyESI, { name: "K\u00E9vin" }));
    expect(component).toMatchSnapshot();
});
test("client-side with serialized props", function () {
    var DummyESI = withESI_1.default(Dummy, "id");
    expect(DummyESI.displayName).toBe("WithESI(Dummy)");
    global.process.browser = true;
    global.__REACT_ESI__ = { id: { name: "Anne" } };
    var component = react_test_renderer_1.default.create(react_1.default.createElement(DummyESI, null));
    expect(component).toMatchSnapshot();
});
test("server-side", function () {
    var DummyESI = withESI_1.default(Dummy, "id");
    expect(DummyESI.displayName).toBe("WithESI(Dummy)");
    process.env.REACT_ESI_SECRET = "dummy";
    global.process.browser = false;
    var component = react_test_renderer_1.default.create(react_1.default.createElement(DummyESI, { esi: { attrs: { onerror: "continue" } }, name: "K\u00E9vin" }));
    expect(component).toMatchSnapshot();
});
//# sourceMappingURL=withESI.test.js.map